/*

    Zelda Return of the Hylian

    Copyright (C) 2005-2008  Vincent Jouillat

    Please send bugreports with examples or suggestions to www.zeldaroth.fr

*/

#include <SDL/SDL.h>
#include <SDL/SDL_image.h>

#include "Texte.h"
#include "Menu.h"
#include "Joueur.h"
#include "Monde.h"
#include "Projectile.h"
#include "Jeu.h"

Texte::Texte(Jeu* jeu) : gpJeu(jeu), vitesse(40), av(0), x(0), y(0), w(0), h(0),
id(0), idsuiv(0), def(false), cadre(false), texte(""), buffer("") {
    lastAnimTime = SDL_GetTicks();
    imageFont = IMG_Load("data/images/texte/font.png");
    SDL_SetColorKey(imageFont,SDL_SRCCOLORKEY,SDL_MapRGB(imageFont->format,0,0,255));
    imageCoeur = IMG_Load("data/images/menu/coeur.png");
    SDL_SetColorKey(imageCoeur,SDL_SRCCOLORKEY,SDL_MapRGB(imageCoeur->format,0,0,255));
}

Texte::~Texte() {
    SDL_FreeSurface(imageFont);
    SDL_FreeSurface(imageCoeur);
}

void Texte::chercheText() {
    ostringstream os;
    int tmp;
    switch (id) {
        case 1  : texte = "Du hast ein Schild gefunden!!!**Deine Rstung steigert sich um einen Punkt!"; break;
        case 2  : texte = "Du hast ein Schwert gefunden!!!**Du kannst jetzt Monster angreifen (drck Z oder W)!!!*Halte Z um den Spezialhieb aufzuladen!!!"; break;
        case 3  :
            tmp = 4-(gpJeu->getJoueur()->nbQuarts()%4);
            os << tmp;
            texte = "Du hast ein Herzfragment gefunden!!!";
            if (tmp<4) buffer = "Noch "+os.str()+" fr ein neues Herz ntig!!!";
            else buffer = "Deine Herzanzahl hat sich gerade erhht!!!";
            break;
        case 11 : texte = "N: Link's zu Hause*W: Hyrule-Gebiet*O: Wald-Tempel"; break;
        case 12 : texte = "Berg-Tempel**Nichts fr Herzkranke, Angsthasen und Schlappschwnze."; break;
        case 13 : texte = "W: Wste Gerudo*N: Berg-Tempel"; break;
        case 14 : texte = "N: Berg-Tempel*S: Hyrule Gebiet"; break;
        case 15 : texte = "N: Todesschlucht"; break;
        case 16 : texte = "O: Zum Wald"; break;
        case 17 : texte = "S: See Hylia*O: Spuk-Friedhof"; break;
        case 18 : texte = "S: Zum Dorf Kakariko"; break;
        case 19 : texte = "N: Dorf Kakariko"; break;
        case 20 : texte = "N: Hyrule-Gebiet"; break;
        case 21 : texte = "W: Feuer-Land"; break;
        case 22 : texte = "O: Dorf der Schatten*- Nicht fr Lebendige -"; break;
        case 23 : texte = "Dunkler Tempel**Bist du ein Geist, der Arbeit sucht? Dann solltest du dich bei uns melden."; break;
        case 24 : texte = "N: Dorf der Schatten*W: See Hylia"; break;
        case 25 : texte = "N: Spuk-Friedhof**Kein Zutritt"; break;
        case 26 : texte = "Dorf der Schatten"; break;
        case 27 : texte = "Ich verkaufe eine Flasche fr 100 Rupien, abgemacht?*               JA ?          nein  ";
            if ((gpJeu->getJoueur()->hasBouteille(0) && gpJeu->getZone()==8)
            || (gpJeu->getJoueur()->hasBouteille(1) && gpJeu->getZone()==5)
            || (gpJeu->getJoueur()->hasBouteille(2) && gpJeu->getZone()==6)) {id=32; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<100) idsuiv=29;
            else idsuiv=30;
            break;
        case 28 : texte = "Ich verkaufe eine Flasche fr 100 Rupien, abgemacht?*               ja            NEIN ?"; idsuiv=31; break;
        case 29 : texte = "Bedaure, du hast leider nicht genug Rupien"; break;
        case 30 : texte = "Danke, hier ist die Flasche."; break;
        case 31 : texte = "Komm wieder, falls sich deine Meinung gendert hat."; break;
        case 32 : texte = "Das war leider meine einzige Flasche."; break;
        case 33 : texte = "Du hast eine leere Flasche gekauft!!!**Darin kannst du Getrnke aufbewahren!!!"; break;
        case 35 : texte = "Die Einwohner dieses Dorfes sprechen einen ungewhnlichen Dialekt, nix versteh'n..."; break;
        case 36 : texte = "@+@+@+@+@+@+@@@+*@=++=@=+@=+@=+=@*+@+@+@+=+="; break;
        case 37 : texte = "Falls du wirklich hier hindurch willst, musst du erst den Dorfltesten fragen!!!"; break;
        case 38 : texte = "Der Dorflteste erlaubt dir also zu passieren??? Grrrr... Dann geh doch!!!"; break;
        case 39 : texte = "Geh mir aus dem Weg!!!"; break;
        case 40 : texte = "Normalerweise kommen keine Touristen hier her."; break;
        case 41 : texte = "Einheimische Monster frchten sich kaum vor etwas. Zum Glck berfallen sie nur Menschen."; break;
        case 42 : texte = "Wirklich?*Verstehst du, was ich sage?"; break;
        case 43 : texte = "N: Wste und Dorf Gerudo"; break;
        case 44 : texte = "S: See Hylia*W: Schloss Hyrule"; break;
        case 45 : texte = "Dorf Kakariko"; break;
        case 46 : texte = "W: Schloss Hyrule"; break;
        case 47 : texte = "Was fr ein schner Tag!!!"; break;
        case 48 : texte = "Aber warum soll ich auf dieses Viehzeug aufpassen???*Ich hasse Hhner!!!"; break;
        case 49 : texte = "Im Dorfladen kannst du viele ntzliche Dinge kaufen."; break;
        case 50 : texte = "S: Dorf Kakariko*W: Wste Gerudo*O: Todesschlucht"; break;
        case 51 : texte = "Dorf Gerudo"; break;
        case 52 : texte = "Verirrt in der Wste?*Du bist hier:*                        X"; break;
        case 54 : texte = "S: Zum Schloss Hyrule"; break;
        case 55 : texte = "Wsten-Tempel**Tritt ein fr ein Bad.*(Das Wasser ist nicht zum Trinken da!)"; break;
        case 56 : texte = "Wald-Tempel**Schtze die Bume, fang die Biber!!!"; break;
        case 57 : texte = "See-Tempel**Badekappen vorgeschrieben!"; break;
        case 58 : texte = "Eis-Tempel**Das Personal mchte dich daran erinnern, dass ein Tempel keine Eissporthalle ist."; break;
        case 59 : texte = "Warst du schon beim Dorfschmied?*Man sagt, er sei sehr begabt, die Ausrstung fr Abenteurer aufzuwerten. Er hat viele Kunden."; break;
        case 60 : texte = "Der Tempel ist in der tiefsten Wste, in einer antiken Oase."; break;
        case 61 : texte = "S: Feuerland*O: Dorf Kakariko"; break;
        case 62 : texte = "Schloss Hyrule"; break;
        case 63 : texte = "O: Dorf Kakariko"; break;
        case 64 : texte = "W: Schildkrtfelsen*O: See Hylia"; break;
        case 65 : texte = "Geheim-Tempel**Hier ruht das Schwert Excalibur."; break;
        case 66 : texte = "N: Zum Spuk-Friedhof"; break;
        case 67 : texte = "Du hast den Tempelplan gefunden!!!*Drck P, um den Plan anzusehen."; break;
        case 68 : texte = "Du hast den Kompass gefunden!!!*Du kannst nun den Boss und die Truhen auf dem Plan sehen."; break;
        case 69 : texte = "Du hast den Boss-Schlssel gefunden!!!"; break;
        case 70 : texte = "Du hast einen Schlssel gefunden!!!*Geh auf eine Tr zu, um diese zu ffnen."; break;
        case 71 : texte = "Du hast die magischen Handschuhe gefunden!!!*Benutz diese (oder drck C) zum Heben/Schieben schwerer Objekte."; break;
        case 72 :
            texte = "Du hast einen Kristall gefunden!!!";
            tmp = 7-gpJeu->getJoueur()->nbCristaux();
            os << tmp;
            if (tmp==6 && !gpJeu->getJoueur()->getAvancement()) buffer = "Fr was mag der wohl gut sein...?";
            else if (tmp>2) buffer = "Es mssen noch "+os.str()+" gefunden werden!!!";
            else if (tmp==2) buffer = "Nur noch 2 Exemplare fehlen noch!!!";
            else if (tmp==1) buffer = "Jetzt fehlt nur noch einer!!!";
            else if (tmp==0) buffer = "Du hast jetzt alle 7 Kristalle. Lauf schnell zum Schloss und rette Zelda!!!";
            break;
        case 80 : texte = "Du hast einen Hakenwerfer gefunden!!!*Damit kannst du einige Hindernisse berwinden."; break;
        case 81 : texte = "Du hast die magische Laterne gefunden!!!*Damit kannst du Feuer entfachen."; break;
        case 82 : texte = "Du hast Schwimmflossen gefunden!!!*Damit kannst du endlich im See baden gehen."; break;
        case 83 : texte = "Du hast einen Hammer gefunden!!!*Damit kannst du Hindernisse zu Brei schlagen."; break;
        case 84 : texte = "Du hast den magischen Feuerstab gefunden!!!*Damit kannst du mchtige Feuerblle schleudern."; break;
        case 85 : texte = "Du hast den magischen Eisstab gefunden!!!*Damit kannst du etwas beliebiges Einfrieren."; break;
        case 86 : texte = "Du hast das Schwert Excalibur gefunden!!!*Selbst Ganon kann nicht seiner Macht standhalten!!! (theoretisch)"; break;
        case 87 : texte = "Endlich Link, du hast mich befreit!!!**Lass uns schnell Ganon finden. Wir mssen unbedingt das Triforce zurck bekommen!"; break;
        case 89 : texte = "Der Geheimgang hinter dem Thron fhrt zu Ganon. Beeil dich!"; break;
        case 90 : texte = "Wir sind nahe dran, folge mir!"; break;
        case 91 : texte = "Ich befrchte, dass du mit den gegenwrtigen Waffen Ganon nicht besiegen kannst...*Geh nach Karariko und sprich mit dem Dorfltesten. Er findet sicher eine Lsung."; break;
        case 92 : texte = "Ganon ist hinter dieser Tr da.*Ich habe soeben alle deine Wunden geheilt!"; break;
        case 93 : texte = "Ganon ist irgendwo hier im Schloss."; break;
        case 94 : texte = "Du solltest auf Prinzessin Zelda warten!!!"; break;
        case 95 : texte = "Wrdest du nicht dieses mulmige Gefhl manchmal loswerden wollen???"; break;
        case 96 : texte = "Zelda wartet auf dich!!!"; break;
        case 97 : texte = "Du hast das Triforce gefunden!!!"; break;
        case 98 : texte = "Du hast das Buch Mudora gefunden!!!**Jetzt kannst du endlich die Sprache der antiken Hylian verstehen!!!"; break;
        case 99 : texte = "Du hast mich gefunden, Link. Zur Belohnung schenke ich dir das Din-Amulett. Dies steigert deine Rstung um einen Punkt."; break;
        case 100 : texte = "Du hast mich gefunden, Link. Zur Belohnung schenke ich dir das Nayru-Amulett. Dies steigert deine Rstung um zwei Punkte!!!"; break;
        case 101 : texte = "..."; break;
        case 102 : texte = "Du hast ein magisches Amulett bekommen!!!**Dies steigert deine Rstung!!!"; break;
        case 103 : texte = "Du hast mich gefunden, Link. Zur Belohnung werde ich deine Zauberkraft verdoppeln!!!"; break;
        case 104 : texte = "Deine Zauberkraft hat sich verdoppelt!!!"; break;
        case 105 : texte = "Komm wieder, wenn du eine leere Flasche hast, dann verkauf ich dir einen roten Trank, der alle Wunden heilt."; break;
        case 106 : texte = "Den roten Heiltrank fr 60 Rupien, abgemacht?*               JA ?          nein  ";
            if (gpJeu->getJoueur()->hasBouteille(0)!=1
            && gpJeu->getJoueur()->hasBouteille(1)!=1
            && gpJeu->getJoueur()->hasBouteille(2)!=1) {id=105; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<60) idsuiv=29;
            else idsuiv=108; break;
        case 107 : texte = "Den roten Heiltrank fr 60 Rupien, abgemacht?*               ja            NEIN ?"; break;
        case 108 : texte = "Danke. Hier ist der Trank."; break;
        case 109 : texte = "Du hast einen roten Trank bekommen!!!*(Stellt die volle Gesundheit wieder her)"; break;
        case 110 : texte = "Du hast einen grnen Trank bekommen!!!*(Stellt die magischen Krfte wieder her)"; break;
        case 111 : texte = "Du hast einen blauen Trank bekommen!!!*(Stellt volle Gesundheit und die magischen Krfte wieder her)"; break;
        case 112 : texte = "Hallo, was mchtest du gerne trinken?"; break;
        case 113 : texte = "-Hick!- Eine Fee flsterte mir ins Ohr... -Hick!- ...derjenige, der mich findet, bekommt etwas besonderes... -Hick!!!-"; break;
        case 114 : texte = "Ein Herz fr 10 Rupien, abgemacht?**               JA ?          nein  ";
            if (gpJeu->getJoueur()->getVie()+gpJeu->getJoueur()->getBoostVie()
            == gpJeu->getJoueur()->getVieMax()) {id=128; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<10) idsuiv=29;
            else idsuiv=129; break;
        case 115 : texte = "Ein Herz fr 10 Rupien, abgemacht?**               ja            NEIN ?"; break;
        case 116 : texte = "Kleiner Zaubertrank fr 20 Rupien, abgemacht?**               JA ?          nein  ";
            if (gpJeu->getJoueur()->getMagie()+gpJeu->getJoueur()->getBoostMagie()
            == gpJeu->getJoueur()->getMagieMax() || !gpJeu->getJoueur()->hasObjet(O_LANTERNE)) {
                id=128; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<20) idsuiv=29;
            else idsuiv=129; break;
        case 117 : texte = "Kleiner Zaubertrank fr 20 Rupien, abgemacht?**               ja            NEIN ?"; break;
        case 118 : texte = "Groer Zaubertrank fr 30 Rupien, abgemacht?**               JA ?          nein  ";
            if (gpJeu->getJoueur()->getMagie()+gpJeu->getJoueur()->getBoostMagie()
            == gpJeu->getJoueur()->getMagieMax() || !gpJeu->getJoueur()->hasObjet(O_LANTERNE)) {
                id=128; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<30) idsuiv=29;
            else idsuiv=129; break;
        case 119 : texte = "Groer Zaubertrank fr 30 Rupien, abgemacht?**               ja            NEIN ?"; break;
        case 120 : texte = "5 Pfeile fr 30 Rupien, abgemacht?**               JA ?          nein  ";
            if (gpJeu->getJoueur()->getFleche() == gpJeu->getJoueur()->getFlecheMax()
            || !gpJeu->getJoueur()->hasObjet(O_ARC)) {id=128; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<30) idsuiv=29;
            else idsuiv=129; break;
        case 121 : texte = "5 Pfeile fr 30 Rupien, abgemacht?**               ja            NEIN ?"; break;
        case 122 : texte = "Eine Bombe fr 30 Rupien, abgemacht?**               JA ?          nein  ";
            if (gpJeu->getJoueur()->getBombe() == gpJeu->getJoueur()->getBombeMax()
            || !gpJeu->getJoueur()->hasObjet(O_SAC_BOMBES)) {id=128; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<30) idsuiv=29;
            else idsuiv=129; break;
        case 123 : texte = "Eine Bombe fr 30 Rupien, abgemacht?**               ja            NEIN ?"; break;
        case 124 : texte = "Ein Bogen fr 1000 Rupien, abgemacht?**               JA ?          nein  ";
            idsuiv=29; break;
        case 125 : texte = "Ein Bogen fr 1000 Rupien, abgemacht?**               ja            NEIN ?"; break;
        case 126 : texte = "Ein Bogen fr 50 Rupien, abgemacht?**               JA ?          nein  ";
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<50) idsuiv=29;
            else idsuiv=129; break;
        case 127 : texte = "Ein Bogen fr 50 Rupien, abgemacht?**               ja            NEIN ?"; break;
        case 128 : texte = "Das brauchst du jetzt nicht."; break;
        case 129 : texte = "Danke."; break;
        case 130 : texte = "Du hast den Bogen bekommen!!!*Damit kannst du auf entfernte Ziele schieen."; break;
        case 131 : texte = "Whle, was du begehrst."; break;
        case 132 : texte = "Was???*Du hast einen Auftrag vom Dorfltesten???*Nun gut, dann gebe ich dir einen Preisnachlass auf den Bogen."; break;
        case 133 : texte = "Hallo Link. Ich bin der Dorflteste. Ich dachte mir schon, dass du zu mir kommen wirst."; idsuiv=134; break;
        case 134 : texte = "Seit heute frh treiben sich Monster in Hyrule herum. Ich versuchte darber mit Zelda zu sprechen, aber wie du bereits sagtest, blockiert ein Zauberbann den Eingang zum Schloss..."; idsuiv=136; break;
        case 136 : texte = "Du sagst, Ganon sei Schuld fr all dies? Er soll das Triforce gestohlen und Prinzessin Zelda gefangen halten?"; idsuiv=137; break;
        case 137 : texte = "Mmmm... Die Situation ist ernster, als ich dachte..."; idsuiv=138; break;
        case 138 : texte = "Wir mssen rasch handeln. Du musst erneut gegen Ganon kmpfen!"; idsuiv=139; break;
        case 139 : texte = "Wie kommt man ins Schloss? Ich htte da eine Idee..."; idsuiv=140; break;
        case 140 : texte = "Wie bekannt, wurden die Krfte der 7 Weisen von Zauberer Aghanim in 7 Kristalle gesperrt, als er versuchte den Pfad zur Dunklen Welt zu ffnen, wo Ganon sich aufhlt."; idsuiv=141; break;
        case 141 : texte = "Jetzt, nachdem du Ganon besiegt, das Triforce gefunden und damit die 7 Weisen wiederbelebt hast, haben diese Kristalle ihre magischen Krfte immer noch erhalten."; idsuiv=142; break;
        case 142 : texte = "Sie sind tief im Inneren der 7 Tempel versteckt worden. Hol sie dir alle, dann kannst du Ganon's Zauberbann am Schlosseingang lsen."; idsuiv=143; break;
        case 143 : texte = "Das wird jedoch nicht einfach werden, denn Ganon hat sicher seine besten Einheiten zum Schutz dieser Kristalle eingesetzt..."; idsuiv=144; break;
        case 144 : texte = "Zu guter Letzt: Du wirst mit deiner jetzigen Ausrstung nicht weit kommen. Geh zum Waffenhndler und sage ihm, dass du in meinem Auftrag kommst. Er wird sich dann wohl erkenntlich zeigen."; break;
        case 145 : texte = "Geh zum Waffenhndler und sage ihm, dass du in meinem Auftrag kommst! Er wird sich dann wohl erkenntlich zeigen."; break;
        case 146 : texte = "Du brauchst alle 7 Kristalle, um Zelda und Hyrule retten zu knnen."; break;
        case 147 : texte = "Du besitzt alle 7 Kristalle? Geh nun geradewegs zum Schloss und befrei' erst die Prinzessin. Sie wird besser als ich wissen, wie Hyrule gerettet werden kann."; break;
        case 148 : texte = "Sind deine Waffen gegen Ganon null und nichtig? Deswegen musst du das Schwert Excalibur finden. Man sagt, es sei gut versteckt in einem Geheim-Tempel."
            "*Nebenbei: Der Weg zum Schwert Excalibur fhrt mitten durch ein Dorf, nur von Monstern bewohnt... Ich frag mich, ob es so ein Dorf gibt..."; break;
        case 150 : texte = "Nun, ich befrchte dass deine Ausrstung unzulnglich ist, um diesen Tempel zu erreichen. Du solltest zum Schmied von Gerudo gehen..."; break;
        case 151 : texte = "Es ist jetzt an der Zeit, Ganon ins Auge zu blicken und ihm das Triforce abzunehmen!"; break;
        case 152 : texte = "Heh! Du musst erst bezahlen, wenn du eine meiner Truhen ffnen willst!!!"; break;
        case 153 : texte = "Eine dieser Truhen enthlt ein Herzfragment. Willst du fr 10 Rupien dein Glck versuchen? Du darfst nur eine Truhe ffnen, abgemacht?*                JA ?          nein";
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<10) idsuiv=29; break;
        case 154 : texte = "Eine dieser Truhen enthlt ein Herzfragment. Willst du fr 10 Rupien dein Glck versuchen? Du darfst nur eine Truhe ffnen, abgemacht?*                ja            NEIN ?"; break;
        case 155 : texte = "Whle eine Truhe."; break;
        case 156 : texte = "Ich habe leider keine Preise mehr fr dieses Spiel, bedaure."; break;
        case 157 : texte = "Du hast verloren! Diese Truhe war leer. Versuch es noch einmal!"; break;
        case 158 : texte = "Hallo! Falls du den Schmied suchst, er wohnt etwas abseits."; break;
        case 159 : texte = "Hallo Link, ich bin der Dorflteste hier.*Du solltest zum Schmied gehen und ihm zeigen, was du brauchst, damit er deine Ausrstung verbessern kann.";
            buffer = "Ich kannte dein Anliegen schon, deshalb habe ich bereits mit ihm gesprochen.*Alles wird fr dich kostenlos erledigt."; break;
        case 160 : texte = "Du brauchst diesen Trank jetzt nicht zu benutzen."; break;
        case 161 : texte = "Grner Zaubertrank fr 40 Rupien, einverstanden?*               JA ?          nein  ";
            if (gpJeu->getJoueur()->hasBouteille(0)!=1
            && gpJeu->getJoueur()->hasBouteille(1)!=1
            && gpJeu->getJoueur()->hasBouteille(2)!=1) {id=163; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<40) idsuiv=29;
            else idsuiv=108; break;
        case 162 : texte = "Grner Zaubertrank fr 40 Rupien, einverstanden?*               ja            NEIN ?"; break;
        case 163 : texte = "Komm wieder, wenn du eine leere Flasche hast, dann verkauf ich dir einen grnen Trank, welcher die Zauberkraft wiederherstellt."; break;
        case 164 : texte = "Komm spter wieder, ich bin zu sehr beschftigt!"; break;
        case 165 : texte = "Kann ich etwas fr dich tun?";
            if (gpJeu->getJoueur()->getEpee()==1) {id=166; chercheText();break;}
            if (gpJeu->getJoueur()->hasObjet(O_GANTS)==1 && gpJeu->getJoueur()->getObjet()==8) {
                id=169; chercheText();break;}
            if (gpJeu->getJoueur()->hasObjet(O_ARC)==2 && gpJeu->getJoueur()->getObjet()==0
            && gpJeu->getJoueur()->nbCristaux()==7) {
                id=172; chercheText();break;}
            break;
        case 166 : texte = "Soll ich dein Schwert hrten?**               JA ?          nein  "; break;
        case 167 : texte = "Soll ich dein Schwert hrten?**               ja            NEIN ?"; break;
        case 168 : texte = "Dein Schwert hat seine Kraft verdreifacht. Auerdem kann es jetzt magische Hiebe schleudern, da guckst du!!!*"; break;
        case 169 : texte = "Soll ich deine Handschuhe aufwerten?**               JA ?          nein  "; break;
        case 170 : texte = "Soll ich deine Handschuhe aufwerten?**               ja            NEIN ?"; break;
        case 171 : texte = "Die Kraft deiner Handschuhe ermglicht dir nun, schwere Brocken zu heben."; break;
        case 172 : texte = "Soll ich deinen Bogen aufwerten?**               JA ?          nein  "; break;
        case 173 : texte = "Soll ich deinen Bogen aufwerten?**               ja            NEIN ?"; break;
        case 174 : texte = "Dein Bogen verwendet nun Silberpfeile mit kataklystischer Energie!!!"; break;
        case 175 : texte = "Komm wieder, wenn du eine leere Flasche hast, dann verkauf ich dir den blauen Trank, der Gesundheit und Zauberkraft wiederherstellt."; break;
        case 176 : texte = "Der blaue Zaubertrank fr 160 Rupien, einverstanden?*               JA ?          nein  ";
            if (gpJeu->getJoueur()->hasBouteille(0)!=1
            && gpJeu->getJoueur()->hasBouteille(1)!=1
            && gpJeu->getJoueur()->hasBouteille(2)!=1) {id=175; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<160) idsuiv=29;
            else idsuiv=108; break;
        case 177 : texte = "Der blaue Zaubertrank fr 160 Rupien, einverstanden?*               ja            NEIN ?"; break;
        case 178 : texte = "Unser Dorfltester hat festgelegt, unvorsichtige Abenteurer vom Tempel fernzuhalten. Ich erlaube niemandem zu passieren."; break;
        case 179 : texte = "Mmmm... Du hast bereits 4 Kristalle gefunden?*Ich muss zugeben, dass du mich beeindruckst...";
            buffer = "Nun gut, du darfst das Grberfeld berqueren, aber auf eigenes Risiko."; break;
        case 181 : texte = "Sag dem Wchter im Norden des Dorfes, dass er dich durchlassen soll."; break;
        case 182 : texte = "Ach soo, du lebst immer noch...*Erstaunlich."; break;
        case 183 : texte = "Der Dunkle Tempel ist der Startpunkt des Weges zum Erreichen eines legendren Objektes. Dieses Dorf existiert nur deshalb, um Abenteurer davon fern zu halten."; break;
        case 184 : texte = "Du hast also das Schwert Excalibur gefunden?*Aber glaub' nicht, dass du es fr immer behalten kannst.";
            buffer = "Das Schwert Excalibur ist eines der wertvollsten Kulturgter von Hyrule, zusammen mit dem Triforce. Du wirst es am Ende deiner Mission in den Altarraum zurck legen!"; break;
        case 186 : texte = "Alle Bewohner dieses Dorfes sind Geister, die Prinzessin Zelda's Anweisungen treu befolgen."; break;
        case 187 : texte = "Als der Frieden in Hyrule wieder einzog und die Lichtwelt mit dem Goldenen Land wieder vereinigt war, bat Zelda (heimlich) einige Geister diese Stadt zu errichten,";
            buffer = "um den Zugang zu einem sehr wertvollen Objekt zu blockieren."; break;
        case 189 : texte = "Willkommen Link!*Lass mich dir erklren, was ich hier mache."; idsuiv=190; break;
        case 190 : texte = "Wie du sicher bemerkt hast, sind Monster in Hyrule aufgetaucht. Es ist das erste mal, seit deinem Sieg ber Ganon, dass ich Monster beobachte."; idsuiv=191; break;
        case 191 : texte = "Nun habe ich beschlossen, alle Monster zu katalogisieren."; idsuiv=192; break;
        case 192 : texte = "Unglcklicherweise bin ich wirklich zu ngstlich, diesen persnlich zu begegnen. Deshalb brauche ich deine Hilfe."; idsuiv=193; break;
        case 193 : texte = "Du musst jede unbekannte Monster-Art besiegen und mir im Anschluss davon berichten."; idsuiv=194; break;
        case 194 : texte = "Jedes mal, wenn du 7 neue Arten von Monstern besiegt hast, gebe ich dir ein Herzfragment dafr."; idsuiv=195; break;
        case 195 : texte = "Willst du wissen, welche Monster du bereits besiegt hast, dann drck M."; break;
        case 196 :
            if (gpJeu->getJoueur()->getCoeur(43)) {
                if (gpJeu->getJoueur()->nbEnnemis() >= 46) {id=205; chercheText();return;}
                else {id=204; chercheText();return;}
            }
            for (int i = 38; i < 44; i++)
                if (!gpJeu->getJoueur()->getCoeur(i)
                && (gpJeu->getJoueur()->nbEnnemis()/7)+37>=i) {
                    id=203; chercheText();return;
                }
            tmp = 7-(gpJeu->getJoueur()->nbEnnemis()%7);
            os << tmp;
            if (tmp>1) texte = "Abermals "+os.str()+" unbekannte Monster bis zur nchsten Belohnung.";
            else texte = "Du bentigst nur noch ein unbekanntes Monster bis zur nchsten Belohnung!!!";
            break;
        case 203 : texte = "Nimm dieses Geschenk fr deine tatkrftige Untersttzung meines Projekts:"; break;
        case 204 : texte = "Tut mir leid, aber ich habe keine Geschenke mehr fr dich..."; break;
        case 205 : texte = "Ich kann es nicht fassen. Dir gelang es, alle Monster-Arten zu besiegen!!!*Gratulation, Link!!!"; break;
        case 206 : texte = "                    Level 1:**                  Wald-Tempel"; break;
        case 207 : texte = "                    Level 2:**                 Wasser-Tempel"; break;
        case 208 : texte = "                    Level 3:**                  Berg-Tempel"; break;
        case 209 : texte = "                    Level 4:**                 Wsten-Tempel"; break;
        case 210 : texte = "                    Level 5:**                 Dunkler Tempel"; break;
        case 211 : texte = "                    Level 6:**                  Feuer-Tempel"; break;
        case 212 : texte = "                    Level 7:**                   Eis-Tempel"; break;
        case 213 : texte = "                    Level ?:**                 Geheim-Tempel"; break;
        case 214 : texte = "                 Letzter Level:**                 Schloss Hyrule"; break;

        case 215 :texte = "                  Schon mde?                   ?               WEITER MACHEN               ?               Sichern und beenden                          Beenden ohne zu sichern           "; break;
        case 216 :texte = "                  Schon mde?                                   weiter machen                  ?            SICHERN UND BEENDEN            ?             Beenden ohne zu sichern           "; break;
        case 217 :texte = "                  Schon mde?                                   weiter machen                               Sichern und beenden               ?          BEENDEN OHNE ZU SICHERN          ?"; break;

        case 223 : texte = "Als Link das Triforce berhrte, verschwanden auch alle Monster und Frieden zog ein.**"
          "Dann fasste Prinzessin Zelda einen mutigen Entschluss: Sie berhrte kreisend das Triforce und wnschte sich etwas.**"
          "Das Triforce hat schon genug Probleme im Knigreich verursacht. Frher oder spter wird erneut ein Bsewicht das Triforce finden.**"
          "Im gleichen Moment, als die Prinzessin die Reliquie berhrte, verschwand diese fr immer von Hyrule.";
          buffer = "Seit diesem Tag lebten die Bewohner von Hyrule in Frieden, ohne Angst vor neuem Unheil.**"
          "Deshalb ist die Geschichte von Zelda, dem Triforce und dem Goldenen Land Hyrule hiermit beendet.**"
          "Das Schwert Excalibur gilt als sicher verwahrt (-irgendwo an einem geheimen Ort-) und ist Link's jngstes Beutestck..."; break;
        case 224 : texte = "Du hast mich gefunden, Link. Zur Belohnung schenke ich dir das Farore-Amulett. Dies steigert deine Rstung um einen Punkt..."; break;
        case 225 : texte = "Mchtest du dein Spiel sichern?**                    ?  JA  ?*                      nein  "; break;
        case 226 : texte = "Mchtest du dein Spiel sichern?**                       ja   *                    ? NEIN ?"; break;
        case 227 : texte = "Spielstand gesichert."; break;
        case 228 : texte = "Das Knigreich Hyrule lebte in Frieden, seit Link, der letzte Ritter von Hyrule, den heimtckischen Ganon besiegte und das wertvolle Triforce von ihm zurckgewann."; idsuiv = 229; break;
        case 229 : texte = "Niemand kennt die Worte von Link's Wunsch an das Triforce, allerdings hat dieser die Wiedervereinigung der Hellen mit der Dunklen Welt bewirkt, sowie *die Auferstehung der 7 Weisen."; idsuiv = 230; break;
        case 230 : texte = "Schlielich bergab Link das Triforce und das Schwert Excalibur an Prinzessin Zelda, und die Leute begannen zu glauben, dass nun fr immer Frieden herrschen wird.                        Aber die Leute lagen falsch..."; idsuiv=231; break;
        case 231 : texte = "... denn unglcklicherweise hatte Link's Wunsch auch negative Auswirkungen. Ganon und seine Schergen sind wiederauferstanden und machen sich kampfbereit."; idsuiv=232; break;
        case 232 : texte = "Irgendwo im Wald von Hyrule schlft Link und ahnt noch nicht, dass Ganon bereits den Kampf begonnen hat,";
            buffer="bis eine wohlbekannte Stimme zu ihm spricht, whrend er weiter fest schlft..."; break;
        case 233 : texte = "Hilf mir!*Hilf mir!*Ich bin's, Zelda!*Ich spreche zu dir ber Telepathie."; idsuiv = 234; break;
        case 234 : texte = "Ich bin Gefangene im Kerker des Schlosses!*Ich brauche deine Hilfe!*Ganon ist zurckgekehrt, und er hat bestimmt schon das Triforce gefunden..."; idsuiv=235; break;
        case 235 : texte = "Komm schnell zu mir ins Schloss, Link, du bist meine einzige Hoffnung..."; break;
        case 236 : texte = "Brauchst du HILFE, dann drck F1."; break;
    }
}

void Texte::affiche(SDL_Surface* gpScreen, std::string s, int a, int b) {
    for (int i = 0; i < (int)s.length(); i++) {
        afficheLettre(gpScreen, s.at(i),a,b);
        a+=6;
    }
}

void Texte::draw(SDL_Surface* gpScreen) {

    if (cadre) drawCadre(gpScreen);

    if (id==3 && texte == "Du hast ein Herzfragment gefunden!!!") {
        SDL_Rect src; SDL_Rect dst;
        src.x=16*(gpJeu->getJoueur()->nbQuarts()%4);
        if(src.x==0)src.x=16*4;
        src.y=0; src.w=16; src.h=16; dst.x=160-8; dst.y=120-8+16*5;
        SDL_BlitSurface(imageCoeur, &src, gpScreen, &dst);
    }

    int a = x+8; int b = y+8;
    for (int i = 0; i < av; i++) {
        afficheLettre(gpScreen, texte.at(i),a,b);
        a+=6;
        if (a > x+w-16) {a=x+8; b+=16;}
    }

    if(SDL_GetTicks() > lastAnimTime + vitesse && def && av < (int)texte.length()) {
        lastAnimTime = SDL_GetTicks();
        do av++;
        while (av < (int)texte.length() && texte.at(av-1) == ' ');
        if (texte.at(av-1) != ' ') gpJeu->getAudio()->playSound(0,1);
    }
}

bool Texte::isFinished() {return (av==(int)texte.length());}

int Texte::getId() {return id;}

void Texte::changeId(int i) {
    id=i; idsuiv=0; buffer="";
    chercheText();
    decoupeText();
    if (av>(int)texte.length()) av=(int)texte.length();
}

void Texte::drawCadre(SDL_Surface* gpScreen) {
    SDL_Rect src;
    SDL_Rect dst;

    src.w=8; src.h=8; src.x = 103; src.y = 100; dst.x = x; dst.y = y;
    SDL_BlitSurface(imageFont, &src, gpScreen, &dst);

    src.x = 112;
    for (int i = 8; i < w-8; i+=16) {
        dst.x = x+i; src.w=16;
        while (dst.x + src.w > x+w && src.w>0) src.w--;
        if (src.w>0) SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    }

    src.w=8; src.x = 129; dst.x = x+w-8;
    SDL_BlitSurface(imageFont, &src, gpScreen, &dst);

    src.y = 109; src.w=8;
    for (int j = 8; j < h-8; j+=16) {
        dst.y = y + j;
        src.x = 103; dst.x = x; src.h=16;
        while (dst.y + src.h > y+h && src.h>0) src.h--;
        if (src.h>0) SDL_BlitSurface(imageFont, &src, gpScreen, &dst);

        src.x = 129; dst.x = x+w-8;
        if (src.h>0)SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    }

    src.h=8; src.x = 103; src.y = 126; dst.x = x; dst.y = y+h-8;
    SDL_BlitSurface(imageFont, &src, gpScreen, &dst);

    src.x = 112;
    for (int i = 8; i < w-8; i+=16) {
        dst.x = x+i; src.w=16;
        while (dst.x + src.w > x+w && src.w>0) src.w--;
        if (src.w>0) SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    }

    src.w=8; src.x = 129; dst.x = x+w-8;
    SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
}

void Texte::setTexte(int idTxt, int vx, int vy, int vw, int vh, bool cadr, bool defil, int vit) {
    if (idTxt == 0) return;
    id = idTxt;
    idsuiv = 0;
    buffer = "";
    chercheText();

    x = vx; y = vy; w = vw; h = vh;
    decoupeText();

    def=defil;
    if (def) av = 0;
    else av = texte.length();

    cadre = cadr;

    vitesse = vit;
}

void Texte::decoupeText() {
    //compte le nombre de caractres possibles et largeur et en hauteur
    int nbcol = (w-16)/6 -1;
    int nblig = (h-16)/16;
    int tailleMax = nbcol * nblig;
    int taille;

    //parcours du texte  afficher;  chaque dbut de mot,
    //vrifie que le mot peut tenir sur la ligne
    for (int i = 0; i < (int)texte.length(); i++) {

        //supprime les espaces isols en dbut de ligne
        if (texte.at(i)==' ' && texte.at(i+1)!=' ' && i%nbcol == 0) texte.erase(i,1);
        //recherche du dbut du prochain mot
        while(texte.at(i)==' ' && i < (int)texte.length()-1) i++;

        //saute une ligne si trouve une toile
        if (texte.at(i)=='*') {
            texte.erase(i,1);//replace(i, 1, " ");
            int nb = (nbcol)-(i%(nbcol));
            for (int j = 0; j < nb; j++) texte.insert(i," ");
            continue;
        }

        //si le mot dpasse
        taille = tailleMot(i);
        if ((i%nbcol)+taille>nbcol) {
            if  (i < tailleMax) {
                //si le mot ne tient pas sur une ligne, on le coupe avec des tirets
                if (taille>nbcol) {
                    texte.insert(((i/nbcol)+1)*nbcol-1,"--");
                    i = 1+((i/nbcol)+1)*nbcol;
                }
                //sinon, on ajoute des espaces pour faire commencer le mot  la ligne
                else while((i%nbcol) != 0) {texte.insert(i," "); i++;}
            }
        }

    }

    // si le texte est trop grand, on le coupe en deux
    if ((int)texte.length() > tailleMax) {
        buffer = texte.substr(tailleMax);
        texte = texte.substr(0, tailleMax);
    }
}

int Texte::tailleMot(int deb) {
    int i = deb;
    int total = 0;
    while (texte.at(i)!=' ') {total++; i++; if (i >= (int)texte.length()) return total;}
    return total;
}

void Texte::afficheLettre(SDL_Surface* gpScreen, char c, int vx, int vy) {
    SDL_Rect src;
    SDL_Rect dst;

    int val = (int)c;

    dst.x=vx; dst.y=vy;
    src.h=16;src.w=8;
//std::cout<<((int)'')<<" "<<((int)'')<<" "<<((int)'')<<endl;
    if(val==32) return;
    
    // 
    if(val==-33) {src.x=6+16*3; src.y=167;}
    
    // 
    if(val==-60) {src.x=6; src.y=167;}
    
    // 
    if(val==-42) {src.x=6+16; src.y=167;}
    
    // 
    if(val==-36) {src.x=6+16*2; src.y=167;}

    // /
    if(val==47) {src.x=52;src.y=151;}

    // @ hylien
    if(val==64) {src.x=4;src.y=151;}

    // + hylien
    if(val==43) {src.x=20;src.y=151;}

    // = hylien
    if(val==61) {src.x=36;src.y=151;}

    //minuscules a-z
    if(val>=97 && val<=122) {src.x=4+16*((val-97)%10); src.y=52+16*((val-97)/10);}

    //majuscules A-Z
    if(val>=65 && val<=90) {src.x=6+16*((val-65)%10); src.y=2+16*((val-65)/10);}
    // 
    if(val==-25) {src.x=148;src.y=34;}
    // 
    if(val==-23) {src.x=100;src.y=84;}
    // 
    if(val==-22) {src.x=116;src.y=84;}
    // 
    if(val==-24) {src.x=132;src.y=84;}
    // 
    if(val==-21) {src.x=132;src.y=151;}
    // 
    if(val==-32) {src.x=148;src.y=84;}
    // 
    if(val==-30) {src.x=148;src.y=103;}
    // 
    if(val==-28) {src.x=148;src.y=135;}
    // 
    if(val==-18) {src.x=84;src.y=119;}
    // 
    if(val==-17) {src.x=116;src.y=151;}
    // 
    if(val==-5) {src.x=84;src.y=103;}
    // 
    if(val==-7) {src.x=148;src.y=151;}
    // 
    if(val==-4) {src.x=116;src.y=135;}
    // 
    if(val==-10) {src.x=132;src.y=135;}
    // 
    if(val==-12) {src.x=148;src.y=119;}

    //ponctuation
    // -
    if(val==45) {src.x=102;src.y=34;}
    // .
    if(val==46) {src.x=118;src.y=34;}
    // ,
    if(val==44) {src.x=134;src.y=34;}
    // !
    if(val==33) {src.x=3;src.y=135;}
    // ?
    if(val==63) {src.x=19;src.y=135;}
    // (
    if(val==40) {src.x=35;src.y=135;}
    // )
    if(val==41) {src.x=51;src.y=135;}
    // ' ( avec @ )
    if(val==39) {src.x=67;src.y=135;}
    // :
    if(val==58) {src.x=83;src.y=135;}
    // ... ( avec % )
    if(val==37) {src.x=101;src.y=135;}
    // >
    if(val==62) {src.x=100;src.y=151;}
    // <
    if(val==60) {src.x=84;src.y=151;}

    //chiffres
    if(val>=48 && val<=57) {src.x=3+16*((val-48)%5); src.y=103+16*((val-48)/5);}

    SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
}

bool Texte::hasNext() {
    return (buffer != "" || idsuiv > 0);
}

bool Texte::suite() {
    if (av < (int)texte.length()) {
        av = texte.length();
        return true;
    }
    if (!hasNext()) {
        gpJeu->getAudio()->playSound(18);
        return gpJeu->finTexte(id);
    }
    if (buffer != "") {
        texte = buffer;
        buffer = "";
    }
    else {
        id = idsuiv;
        idsuiv = 0;
        chercheText();
    }
    decoupeText();
    if (def) av = 0;
    else av = texte.length();
    gpJeu->getAudio()->playSound(17);
    return true;
}
